/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

var ole_aListeEcheance = new Arbre('Compta/Abonnement/listeEcheance.tmpl', 'ole-listEcheance');

// variables de filtre
var ole_journal;
var ole_dateDeb;
var ole_dateFin;
var ole_chkNonEchues;



function ole_init() {
  try {

  	ole_journal = 0;
  	ole_dateDeb = "";
  	ole_dateFin = "";
  	ole_chkNonEchues = false;

  	var aJournaux = new Arbre('ComboListe/combo-journaux.tmpl', 'ole-filtreJournal');
		aJournaux.setParam("Sans_AN", true);
		aJournaux.initTree();

		ole_initArbre();

	} catch (e) {
  	recup_erreur(e);
	}
}


function ole_activeMenu() {
	try {

 		document.getElementById("ole-listEcheance").disabled = false;

	} catch (e) {
  	recup_erreur(e);
	}
}


function ole_cocher() {
	try {
  		var listbox = document.getElementById("ole-listEcheance");
		var item = listbox.getSelectedItem(0);
		var cks = item.getElementsByTagName("listcell");
		if (cks.item(0).getAttribute("checked")=="false") {
			cks.item(0).setAttribute("checked","true");
		} else {
			cks.item(0).setAttribute("checked","false");
		}
	} catch (e) {
  	recup_erreur(e);
	}
}

function ole_toutCocher(id, b) {
	try {
		var listbox = document.getElementById(id);

		var nbLignes = listbox.getRowCount();
		if (nbLignes>0) {
			for(var i=0; i<nbLignes; i++) {
				var item = listbox.getItemAtIndex(i);
				var cks = item.getElementsByTagName("listcell");
				cks.item(0).setAttribute("checked", b);
			}
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function selectOnFiltreJournal() {
	try {
		var menu = document.getElementById("ole-filtreJournal");
		ole_journal = menu.value;
		ole_initArbre();
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_chkAffEcheances() {
	try {
		ole_chkNonEchues = !ole_chkNonEchues;
		ole_initArbre();
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_keyPressOnDateDebut(event) {
	try {
		if (event.keyCode==13) {
			ole_initArbre();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_keyPressOnDateFin(event) {
	try {
		if (event.keyCode==13) {
			ole_initArbre();
		}
	} catch (e) {
		recup_erreur(e);
	}
}


function ole_initArbre() {
	try {

		ole_dateDeb = document.getElementById('ole-dateDebut').value;
		ole_dateFin = document.getElementById('ole-dateFin').value;

		if (!isEmpty(ole_dateDeb) && !isDate(ole_dateDeb)) { showWarning("Date de d\u00E9but incorrecte !"); }
		else if (!isEmpty(ole_dateFin) && !isDate(ole_dateFin)) { showWarning("Date de fin incorrecte !"); }
		else if (!isEmpty(ole_dateDeb) && !isEmpty(ole_dateFin) && !isDateInterval(ole_dateDeb, ole_dateFin)) { showWarning("P\u00E9riode incorrecte !"); }
		else {
			document.getElementById("ole-listEcheance").disabled = true;

			if (!isEmpty(ole_dateDeb)) { ole_dateDeb = prepareDateJava(ole_dateDeb); }
			if (!isEmpty(ole_dateFin)) { ole_dateFin = prepareDateJava(ole_dateFin); }

			ole_aListeEcheance.clearParams();
			if (ole_journal!=0) {
				ole_aListeEcheance.setParam("Journal_Id", ole_journal);
			}
			if (!isEmpty(ole_dateDeb)) {
				ole_aListeEcheance.setParam("DateDeb", ole_dateDeb);
			}
			if (!isEmpty(ole_dateFin)) {
				ole_aListeEcheance.setParam("DateFin", ole_dateFin);
			}
			if (ole_chkNonEchues) {
				ole_aListeEcheance.setParam("NonEchue", ole_chkNonEchues);
			}

			ole_aListeEcheance.initTree(ole_activeMenu);
  	}

	} catch (e) {
		recup_erreur(e);
	}
}


function ole_pressOnGenerer() {
	try {
		if (document.getElementById("ole-listEcheance").getRowCount()==0) { showWarning("Aucune \u00E9ch\u00E9ance \u00E0 g\u00E9n\u00E9rer sur la page !");	}
		else if (!existEcheanceCochee()) { showWarning("Veuillez cocher au moins une \u00E9ch\u00E9ance !");	}
		else if (window.confirm("Voulez-vous g\u00E9n\u00E9rer les \u00E9critures s\u00E9lectionn\u00E9es ?")) {
			ole_genererListeEcriture();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function existEcheanceCochee() {
	try {
		var trouve = false;
		var listbox = document.getElementById("ole-listEcheance");
		var nbLignes = listbox.getRowCount();
		var i = 0;
		while (i<nbLignes && !trouve) {
			var item = listbox.getItemAtIndex(i);
			var cks = item.getElementsByTagName("listcell");
			if (cks.item(0).getAttribute("checked")=="true") {
				trouve=true;
			}
			i++;
		}
		return trouve;
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_genererListeEcriture() {
	try {
		var queryGen = new QueryHttp("Compta/Abonnement/genListeEcriture.tmpl");

		var liste="";
		var listbox = document.getElementById("ole-listEcheance");
		var nbLignes = listbox.getRowCount();
		var i = 0;
		while (i<nbLignes) {
			var item = listbox.getItemAtIndex(i);
			var cks = item.getElementsByTagName("listcell");
			if (cks.item(0).getAttribute("checked")=="true") {
				liste+=cks.item(3).getAttribute("label")+",";
			}
			i++;
		}
		queryGen.setParam("Liste_Ech_Id", liste);

		var result = queryGen.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
		} else {
			ole_initArbre();
			ola_reset();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_pressOnActualiser() {
	try {
		ole_initArbre();
	} catch (e) {
		recup_erreur(e);
	}
}

function ole_pressOnReinit() {
	try {
		ole_journal = 0;
		document.getElementById("ole-filtreJournal").value = ole_journal;
		document.getElementById('ole-dateDebut').value = "";
		document.getElementById('ole-dateFin').value = "";
		ole_chkNonEchues = false;
		document.getElementById('ole-chkAffEcheancesNonEchues').checked = ole_chkNonEchues;
		ole_initArbre();
	} catch (e) {
		recup_erreur(e);
	}
}
